Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3735)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3736)
@@ -25,41 +25,45 @@
 ! -----------------
 ! $Id$
+! Add azimuth and zenith to output file; set long-name attributes; 
+! clean-up coding layout
+! 
+! 3735 2019-02-12 09:52:40Z dom_dwd_user
 ! - Split initialization into initialization of arrays and further initialization
 !   in order to enable reading of restart data.
 ! - Consider restarts in surface data averaging.
 ! - Correct error message numbers
-! 
+!
 ! 3731 2019-02-11 13:06:27Z suehring
 ! Bugfix: add cpp options
-! 
+!
 ! 3727 2019-02-08 14:52:10Z gronemeier
 ! Enable NetCDF output for surface data (suehring, gronemeier)
-! 
+!
 ! 3691 2019-01-23 09:57:04Z suehring
-! Add output of surface-parallel flow speed 
-! 
+! Add output of surface-parallel flow speed
+!
 ! 3648 2019-01-02 16:35:46Z suehring
 ! Rename module and subroutines
-! 
+!
 ! 3646 2018-12-28 17:58:49Z kanani
 ! Bugfix: use time_since_reference_point instead of simulated_time (relevant
 ! when using wall/soil spinup)
-! 
+!
 ! 3614 2018-12-10 07:05:46Z raasch
 ! unused variables removed
-! 
+!
 ! 3572 2018-11-28 11:40:28Z suehring
 ! Added short- and longwave radiation flux arrays (e.g. diffuse, direct,
 ! reflected, resedual) for all surfaces (M. Salim)
-! 
+!
 ! 3494 2018-11-06 14:51:27Z suehring
-! Bugfix in gathering surface data from different types and orientation. 
+! Bugfix in gathering surface data from different types and orientation.
 ! Output of total number of surfaces and vertices added.
 ! String length is output, for more convinient post-processing.
 ! Last actions added.
-! 
+!
 ! 3483 2018-11-02 14:19:26Z raasch
 ! bugfix: missed directives for MPI added
-! 
+!
 ! 3421 2018-10-24 18:39:32Z gronemeier
 ! Add output variables
@@ -77,6 +81,6 @@
 ! ------------
 !> Generate output for surface data.
-!> 
-!> @todo Create namelist file for post-processing tool. 
+!>
+!> @todo Create namelist file for post-processing tool.
 !------------------------------------------------------------------------------!
 
@@ -87,16 +91,16 @@
    USE arrays_3d,                                                              &
        ONLY:  zu, zw
-       
+
    USE control_parameters,                                                     &
        ONLY:  coupling_char, data_output_during_spinup, end_time,              &
               message_string, run_description_header, simulated_time_at_begin, &
               spinup_time, surface_output
-       
+
    USE grid_variables,                                                         &
        ONLY: dx,dy
-       
+
    USE indices,                                                                &
        ONLY: nxl, nxr, nys, nyn, nzb, nzt
-       
+
 #if defined( __netcdf )
    USE NETCDF
@@ -109,7 +113,7 @@
        ONLY:  netcdf_create_att, netcdf_create_dim, netcdf_create_file,        &
               netcdf_create_global_atts, netcdf_create_var, netcdf_handle_error
-       
+
    USE pegrid
-       
+
    USE surface_mod,                                                            &
        ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v,                  &
@@ -119,21 +123,21 @@
 
    TYPE surf_out                      !< data structure which contains all surfaces elements of all types on subdomain
-   
+
       INTEGER(iwp) ::  ns             !< number of surface elements on subdomain
       INTEGER(iwp) ::  ns_total       !< total number of surface elements
       INTEGER(iwp) ::  npoints        !< number of points / vertices which define a surface element (on subdomain)
       INTEGER(iwp) ::  npoints_total  !< total number of points / vertices which define a surface element
-      
+
       INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  s        !< coordinate for NetCDF output, number of the surface element
-      
-      REAL(wp) ::  fillvalue = -9999.9_wp !< fillvalue for surface elements which are not defined
-      
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  azimuth  !< azimuth orientation coordinate for NetCDF output 
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  es_utm   !< E-UTM coordinate for NetCDF output 
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ns_utm   !< E-UTM coordinate for NetCDF output 
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  xs       !< x-coordinate for NetCDF output 
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ys       !< y-coordinate for NetCDF output 
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zs       !< z-coordinate for NetCDF output 
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zenith   !< zenith orientation coordinate for NetCDF output 
+
+      REAL(wp) ::  fillvalue = -9999.0_wp !< fillvalue for surface elements which are not defined
+
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  azimuth  !< azimuth orientation coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  es_utm   !< E-UTM coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ns_utm   !< E-UTM coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  xs       !< x-coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ys       !< y-coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zs       !< z-coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zenith   !< zenith orientation coordinate for NetCDF output
       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  var_out  !< output variables
       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_av   !< variables used for averaging
@@ -141,19 +145,20 @@
       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  polygons !< polygon data of a surface element
    END TYPE surf_out
-   
+
    CHARACTER(LEN=100), DIMENSION(300)       ::  data_output_surf = ' '  !< namelist variable which describes the output variables
-   CHARACTER(LEN=100), DIMENSION(0:1,300)   ::  dosurf = ' '            !< internal variable which describes the output variables 
+   CHARACTER(LEN=100), DIMENSION(0:1,300)   ::  dosurf = ' '            !< internal variable which describes the output variables
                                                                         !<  and separates averaged from non-averaged output
    CHARACTER(LEN=100), DIMENSION(0:1,300)   ::  dosurf_unit = ' '       !< internal variable which holds the unit of the given output variable
-   
+
    INTEGER(iwp) ::  average_count_surf = 0   !< number of ensemble members used for averaging
    INTEGER(iwp) ::  dosurf_no(0:1) = 0       !< number of surface output quantities
 
    INTEGER(iwp) :: nc_stat                   !< error code for netcdf routines
-   INTEGER(iwp), SAVE ::  oldmode            !< save old set-fill-mode of netcdf file (not needed, but required for routine call)
+   INTEGER(iwp) ::  oldmode                  !< save old set-fill-mode of netcdf file (not needed, but required for routine call)
 
    INTEGER(iwp), DIMENSION(0:1) ::  id_dim_s_surf         !< netcdf ID for dimension s
    INTEGER(iwp), DIMENSION(0:1) ::  id_dim_time_surf      !< netcdf ID for dimension time
    INTEGER(iwp), DIMENSION(0:1) ::  id_set_surf           !< netcdf ID for file
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_azimuth_surf   !< netcdf ID for variable azimuth
    INTEGER(iwp), DIMENSION(0:1) ::  id_var_etum_surf      !< netcdf ID for variable Es_UTM
    INTEGER(iwp), DIMENSION(0:1) ::  id_var_nutm_surf      !< netcdf ID for variable Ns_UTM
@@ -162,13 +167,14 @@
    INTEGER(iwp), DIMENSION(0:1) ::  id_var_xs_surf        !< netcdf ID for variable xs
    INTEGER(iwp), DIMENSION(0:1) ::  id_var_ys_surf        !< netcdf ID for variable ys
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_zenith_surf    !< netcdf ID for variable zenith
    INTEGER(iwp), DIMENSION(0:1) ::  id_var_zs_surf        !< netcdf ID for variable zs
    INTEGER(iwp), DIMENSION(0:1) ::  dosurf_time_count = 0 !< count of output time steps
    INTEGER(iwp), DIMENSION(0:1) ::  ntdim_surf            !< number of output time steps
-   
+
    INTEGER(iwp), DIMENSION(0:1,300) ::  id_var_dosurf     !< netcdf ID for output variables
 
    LOGICAL :: first_output(0:1) = .FALSE.                 !< true if first output was already called
-   LOGICAL :: to_netcdf = .TRUE.                          !< flag indicating parallel NetCDF output 
-   LOGICAL :: to_vtk = .TRUE.                             !< flag indicating binary surface-data output that can be further 
+   LOGICAL :: to_netcdf = .TRUE.                          !< flag indicating parallel NetCDF output
+   LOGICAL :: to_vtk = .TRUE.                             !< flag indicating binary surface-data output that can be further
                                                           !< processed to VTK format
 
@@ -182,5 +188,5 @@
 
    TYPE(surf_out) ::  surfaces      !< variable which contains all required output information
-   
+
    SAVE
 
@@ -190,41 +196,41 @@
       MODULE PROCEDURE surface_data_output
    END INTERFACE  surface_data_output
-   
+
    INTERFACE  surface_data_output_averaging
       MODULE PROCEDURE surface_data_output_averaging
    END INTERFACE  surface_data_output_averaging
-   
+
    INTERFACE  surface_data_output_check_parameters
       MODULE PROCEDURE surface_data_output_check_parameters
    END INTERFACE  surface_data_output_check_parameters
-   
+
    INTERFACE  surface_data_output_init
       MODULE PROCEDURE surface_data_output_init
    END INTERFACE  surface_data_output_init
-   
+
    INTERFACE  surface_data_output_init_arrays
       MODULE PROCEDURE surface_data_output_init_arrays
    END INTERFACE  surface_data_output_init_arrays
-   
+
    INTERFACE  surface_data_output_last_action
       MODULE PROCEDURE surface_data_output_last_action
    END INTERFACE  surface_data_output_last_action
-      
+
    INTERFACE  surface_data_output_parin
       MODULE PROCEDURE surface_data_output_parin
    END INTERFACE  surface_data_output_parin
-   
+
    INTERFACE  surface_data_output_rrd_global
       MODULE PROCEDURE surface_data_output_rrd_global
    END INTERFACE  surface_data_output_rrd_global
-   
+
    INTERFACE  surface_data_output_rrd_local
       MODULE PROCEDURE surface_data_output_rrd_local
    END INTERFACE  surface_data_output_rrd_local
-   
+
    INTERFACE  surface_data_output_wrd_global
       MODULE PROCEDURE surface_data_output_wrd_global
    END INTERFACE  surface_data_output_wrd_global
-   
+
    INTERFACE  surface_data_output_wrd_local
       MODULE PROCEDURE surface_data_output_wrd_local
@@ -250,8 +256,8 @@
 ! ------------
 !> This routine counts the number of surfaces on each core and allocates
-!> arrays. 
+!> arrays.
 !------------------------------------------------------------------------------!
    SUBROUTINE surface_data_output_init_arrays
-   
+
       IMPLICIT NONE
 
@@ -259,9 +265,9 @@
 !--   Determine the number of surface elements on subdomain
       surfaces%ns = surf_def_h(0)%ns + surf_lsm_h%ns + surf_usm_h%ns           & !horizontal upward-facing
-                  + surf_def_h(1)%ns                                           & !horizontal downard-facing    
+                  + surf_def_h(1)%ns                                           & !horizontal downard-facing
                   + surf_def_v(0)%ns + surf_lsm_v(0)%ns + surf_usm_v(0)%ns     & !northward-facing
-                  + surf_def_v(1)%ns + surf_lsm_v(1)%ns + surf_usm_v(1)%ns     & !southward-facing   
-                  + surf_def_v(2)%ns + surf_lsm_v(2)%ns + surf_usm_v(2)%ns     & !westward-facing   
-                  + surf_def_v(3)%ns + surf_lsm_v(3)%ns + surf_usm_v(3)%ns       !eastward-facing   
+                  + surf_def_v(1)%ns + surf_lsm_v(1)%ns + surf_usm_v(1)%ns     & !southward-facing
+                  + surf_def_v(2)%ns + surf_lsm_v(2)%ns + surf_usm_v(2)%ns     & !westward-facing
+                  + surf_def_v(3)%ns + surf_lsm_v(3)%ns + surf_usm_v(3)%ns       !eastward-facing
 !
 !--    Determine the total number of surfaces in the model domain
@@ -277,5 +283,5 @@
       surfaces%var_out = surfaces%fillvalue
 !
-!--   If there is an output of time average output variables, allocate the 
+!--   If there is an output of time average output variables, allocate the
 !--   required array.
       IF ( dosurf_no(1) > 0 )  THEN
@@ -283,8 +289,8 @@
          surfaces%var_av = 0.0_wp
       ENDIF
-      
+
    END SUBROUTINE surface_data_output_init_arrays
- 
- 
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -294,5 +300,5 @@
 !------------------------------------------------------------------------------!
    SUBROUTINE surface_data_output_init
-   
+
       IMPLICIT NONE
 
@@ -311,9 +317,9 @@
       INTEGER(iwp) ::  point_index_count !< local counter variable for point index
       INTEGER(iwp) ::  start_count       !< local start counter for the surface index
-      
+
       INTEGER(iwp), DIMENSION(0:numprocs-1) :: num_points_on_pe   !< array which contains the number of points on all mpi ranks
       INTEGER(iwp), DIMENSION(0:numprocs-1) :: num_surfaces_on_pe !< array which contains the number of surfaces on all mpi ranks
       INTEGER(iwp), ALLOCATABLE, DIMENSION(:,:,:) ::  point_index !< dummy array used to check where the reference points for surface polygons are located
-           
+
       REAL(wp) ::  az    !< azimuth angle, indicated the vertical orientation of a surface element
       REAL(wp) ::  off_x !< grid offset in x-direction between the stored grid index and the actual wall
@@ -323,6 +329,6 @@
 
 !
-!--   If output to VTK format is enabled, initialize point and polygon data. 
-!--   In a first step, count the number of points which are defining 
+!--   If output to VTK format is enabled, initialize point and polygon data.
+!--   In a first step, count the number of points which are defining
 !--   the surfaces and the polygons.
       IF ( to_vtk )  THEN
@@ -340,22 +346,22 @@
                k = surf_def_h(0)%k(m) + surf_def_h(0)%koff
 !
-!--            Check if the vertices that define the surface element are already 
+!--            Check if the vertices that define the surface element are already
 !--            defined, if not, increment the counter.
                IF ( point_index(k,j,i) < 0 )  THEN
-                  surfaces%npoints   = surfaces%npoints + 1    
+                  surfaces%npoints   = surfaces%npoints + 1
                   point_index(k,j,i) = surfaces%npoints - 1
                ENDIF
                IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k,j,i+1) = surfaces%npoints - 1
                ENDIF
                IF ( point_index(k,j+1,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
+                  surfaces%npoints       = surfaces%npoints + 1
                   point_index(k,j+1,i+1) = surfaces%npoints - 1
                ENDIF
                IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k,j+1,i) = surfaces%npoints - 1
-               ENDIF           
+               ENDIF
             ENDDO
          ENDDO
@@ -366,19 +372,19 @@
 
             IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
+               surfaces%npoints   = surfaces%npoints + 1
                point_index(k,j,i) = surfaces%npoints - 1
             ENDIF
             IF ( point_index(k,j,i+1) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
+               surfaces%npoints     = surfaces%npoints + 1
                point_index(k,j,i+1) = surfaces%npoints - 1
             ENDIF
             IF ( point_index(k,j+1,i+1) < 0 )  THEN
-               surfaces%npoints       = surfaces%npoints + 1    
+               surfaces%npoints       = surfaces%npoints + 1
                point_index(k,j+1,i+1) = surfaces%npoints - 1
             ENDIF
             IF ( point_index(k,j+1,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
+               surfaces%npoints     = surfaces%npoints + 1
                point_index(k,j+1,i) = surfaces%npoints - 1
-            ENDIF    
+            ENDIF
          ENDDO
          DO  m = 1, surf_usm_h%ns
@@ -388,19 +394,19 @@
 
             IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
+               surfaces%npoints   = surfaces%npoints + 1
                point_index(k,j,i) = surfaces%npoints - 1
             ENDIF
             IF ( point_index(k,j,i+1) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
+               surfaces%npoints     = surfaces%npoints + 1
                point_index(k,j,i+1) = surfaces%npoints - 1
             ENDIF
             IF ( point_index(k,j+1,i+1) < 0 )  THEN
-               surfaces%npoints       = surfaces%npoints + 1    
+               surfaces%npoints       = surfaces%npoints + 1
                point_index(k,j+1,i+1) = surfaces%npoints - 1
             ENDIF
             IF ( point_index(k,j+1,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
+               surfaces%npoints     = surfaces%npoints + 1
                point_index(k,j+1,i) = surfaces%npoints - 1
-            ENDIF     
+            ENDIF
          ENDDO
 !
@@ -410,6 +416,6 @@
 !
 !--            Determine the indices of the respective grid cell inside the
-!--            topography. Please note, j-index for north-facing surfaces 
-!--            ( l==0 ) is identical to the reference j-index outside the grid  
+!--            topography. Please note, j-index for north-facing surfaces
+!--            ( l==0 ) is identical to the reference j-index outside the grid
 !--            box. Equivalent for east-facing surfaces and i-index.
                i = surf_def_v(l)%i(m) + MERGE( surf_def_v(l)%ioff, 0, l == 3 )
@@ -419,16 +425,16 @@
 !--            Lower left /front vertex
                IF ( point_index(k,j,i) < 0 )  THEN
-                  surfaces%npoints   = surfaces%npoints + 1    
+                  surfaces%npoints   = surfaces%npoints + 1
                   point_index(k,j,i) = surfaces%npoints - 1
-               ENDIF 
+               ENDIF
 !
 !--            Upper / lower right index for north- and south-facing surfaces
                IF ( l == 0  .OR.  l == 1 )  THEN
                   IF ( point_index(k,j,i+1) < 0 )  THEN
-                     surfaces%npoints     = surfaces%npoints + 1    
+                     surfaces%npoints     = surfaces%npoints + 1
                      point_index(k,j,i+1) = surfaces%npoints - 1
-                  ENDIF 
+                  ENDIF
                   IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                     surfaces%npoints       = surfaces%npoints + 1    
+                     surfaces%npoints       = surfaces%npoints + 1
                      point_index(k+1,j,i+1) = surfaces%npoints - 1
                   ENDIF
@@ -437,9 +443,9 @@
                ELSEIF ( l == 2  .OR.  l == 3 )  THEN
                   IF ( point_index(k,j+1,i) < 0 )  THEN
-                     surfaces%npoints     = surfaces%npoints + 1    
+                     surfaces%npoints     = surfaces%npoints + 1
                      point_index(k,j+1,i) = surfaces%npoints - 1
-                  ENDIF 
+                  ENDIF
                   IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                     surfaces%npoints       = surfaces%npoints + 1    
+                     surfaces%npoints       = surfaces%npoints + 1
                      point_index(k+1,j+1,i) = surfaces%npoints - 1
                   ENDIF
@@ -448,5 +454,5 @@
 !--            Upper left / front vertex
                IF ( point_index(k+1,j,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k+1,j,i) = surfaces%npoints - 1
                ENDIF
@@ -459,16 +465,16 @@
 !--            Lower left /front vertex
                IF ( point_index(k,j,i) < 0 )  THEN
-                  surfaces%npoints   = surfaces%npoints + 1    
+                  surfaces%npoints   = surfaces%npoints + 1
                   point_index(k,j,i) = surfaces%npoints - 1
-               ENDIF 
+               ENDIF
 !
 !--            Upper / lower right index for north- and south-facing surfaces
                IF ( l == 0  .OR.  l == 1 )  THEN
                   IF ( point_index(k,j,i+1) < 0 )  THEN
-                     surfaces%npoints     = surfaces%npoints + 1    
+                     surfaces%npoints     = surfaces%npoints + 1
                      point_index(k,j,i+1) = surfaces%npoints - 1
-                  ENDIF 
+                  ENDIF
                   IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                     surfaces%npoints       = surfaces%npoints + 1    
+                     surfaces%npoints       = surfaces%npoints + 1
                      point_index(k+1,j,i+1) = surfaces%npoints - 1
                   ENDIF
@@ -477,9 +483,9 @@
                ELSEIF ( l == 2  .OR.  l == 3 )  THEN
                   IF ( point_index(k,j+1,i) < 0 )  THEN
-                     surfaces%npoints     = surfaces%npoints + 1    
+                     surfaces%npoints     = surfaces%npoints + 1
                      point_index(k,j+1,i) = surfaces%npoints - 1
-                  ENDIF 
+                  ENDIF
                   IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                     surfaces%npoints       = surfaces%npoints + 1    
+                     surfaces%npoints       = surfaces%npoints + 1
                      point_index(k+1,j+1,i) = surfaces%npoints - 1
                   ENDIF
@@ -488,5 +494,5 @@
 !--            Upper left / front vertex
                IF ( point_index(k+1,j,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k+1,j,i) = surfaces%npoints - 1
                ENDIF
@@ -500,16 +506,16 @@
 !--            Lower left /front vertex
                IF ( point_index(k,j,i) < 0 )  THEN
-                  surfaces%npoints   = surfaces%npoints + 1    
+                  surfaces%npoints   = surfaces%npoints + 1
                   point_index(k,j,i) = surfaces%npoints - 1
-               ENDIF 
+               ENDIF
 !
 !--            Upper / lower right index for north- and south-facing surfaces
                IF ( l == 0  .OR.  l == 1 )  THEN
                   IF ( point_index(k,j,i+1) < 0 )  THEN
-                     surfaces%npoints     = surfaces%npoints + 1    
+                     surfaces%npoints     = surfaces%npoints + 1
                      point_index(k,j,i+1) = surfaces%npoints - 1
-                  ENDIF 
+                  ENDIF
                   IF ( point_index(k+1,j,i+1) < 0 )  THEN
-                     surfaces%npoints       = surfaces%npoints + 1    
+                     surfaces%npoints       = surfaces%npoints + 1
                      point_index(k+1,j,i+1) = surfaces%npoints - 1
                   ENDIF
@@ -518,9 +524,9 @@
                ELSEIF ( l == 2  .OR.  l == 3 )  THEN
                   IF ( point_index(k,j+1,i) < 0 )  THEN
-                     surfaces%npoints     = surfaces%npoints + 1    
+                     surfaces%npoints     = surfaces%npoints + 1
                      point_index(k,j+1,i) = surfaces%npoints - 1
-                  ENDIF 
+                  ENDIF
                   IF ( point_index(k+1,j+1,i) < 0 )  THEN
-                     surfaces%npoints       = surfaces%npoints + 1    
+                     surfaces%npoints       = surfaces%npoints + 1
                      point_index(k+1,j+1,i) = surfaces%npoints - 1
                   ENDIF
@@ -529,5 +535,5 @@
 !--            Upper left / front vertex
                IF ( point_index(k+1,j,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k+1,j,i) = surfaces%npoints - 1
                ENDIF
@@ -536,14 +542,14 @@
          ENDDO
 !
-!--      Allocate the number of points and polygons. Note, the number of polygons
-!--      is identical to the number of surfaces elements, whereas the number
-!--      of points (vertices), which define the polygons, can be larger.
+!--      Allocate the number of points and polygons. Note, the number of
+!--      polygons is identical to the number of surfaces elements, whereas the
+!--      number of points (vertices), which define the polygons, can be larger.
          ALLOCATE( surfaces%points(3,1:surfaces%npoints) )
          ALLOCATE( surfaces%polygons(5,1:surfaces%ns)    )
 !
 !--      Note, PARAVIEW expects consecutively ordered points, in order to
-!--      unambiguously identify surfaces. 
+!--      unambiguously identify surfaces.
 !--      Hence, all PEs should know where they start counting, depending on the
-!--      number of points on the other PE's with lower MPI rank. 
+!--      number of points on the other PE's with lower MPI rank.
 #if defined( __parallel )
          CALL MPI_ALLGATHER( surfaces%npoints, 1, MPI_INTEGER,                 &
@@ -554,6 +560,6 @@
 
 !
-!--      After the number of vertices is counted, repeat the loops and define the
-!--      vertices. Start with the horizontal default surfaces.
+!--      After the number of vertices is counted, repeat the loops and define
+!--      the vertices. Start with the horizontal default surfaces.
 !--      First, however, determine the offset where couting of points should be
 !--      started, which is the sum of points of all PE's with lower MPI rank.
@@ -564,13 +570,13 @@
             i                 = i + 1
          ENDDO
-          
+
          surfaces%npoints = 0
          point_index      = -1
          npg              = 0
-      
+
          DO  l = 0, 1
             DO  m = 1, surf_def_h(0)%ns
 !
-!--            Determine the indices of the respective grid cell inside the 
+!--            Determine the indices of the respective grid cell inside the
 !--            topography.
                i = surf_def_h(0)%i(m) + surf_def_h(0)%ioff
@@ -578,10 +584,10 @@
                k = surf_def_h(0)%k(m) + surf_def_h(0)%koff
 !
-!--            Check if the vertices that define the surface element are  
+!--            Check if the vertices that define the surface element are
 !--            already defined, if not, increment the counter.
                IF ( point_index(k,j,i) < 0 )  THEN
-                  surfaces%npoints   = surfaces%npoints + 1    
+                  surfaces%npoints   = surfaces%npoints + 1
                   point_index(k,j,i) = point_index_count
-                  point_index_count  = point_index_count + 1               
+                  point_index_count  = point_index_count + 1
                   surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
                   surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
@@ -589,7 +595,7 @@
                ENDIF
                IF ( point_index(k,j,i+1) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k,j,i+1) = point_index_count
-                  point_index_count    = point_index_count + 1 
+                  point_index_count    = point_index_count + 1
                   surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
                   surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
@@ -597,7 +603,7 @@
                ENDIF
                IF ( point_index(k,j+1,i+1) < 0 )  THEN
-                  surfaces%npoints       = surfaces%npoints + 1    
+                  surfaces%npoints       = surfaces%npoints + 1
                   point_index(k,j+1,i+1) = point_index_count
-                  point_index_count      = point_index_count + 1 
+                  point_index_count      = point_index_count + 1
                   surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
                   surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
@@ -605,12 +611,12 @@
                ENDIF
                IF ( point_index(k,j+1,i) < 0 )  THEN
-                  surfaces%npoints     = surfaces%npoints + 1    
+                  surfaces%npoints     = surfaces%npoints + 1
                   point_index(k,j+1,i) = point_index_count
-                  point_index_count    = point_index_count + 1 
+                  point_index_count    = point_index_count + 1
                   surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
                   surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
                   surfaces%points(3,surfaces%npoints) = zw(k)
                ENDIF
-               
+
                npg                        = npg + 1
                surfaces%polygons(1,npg)   = 4
@@ -626,7 +632,7 @@
             k = surf_lsm_h%k(m) + surf_lsm_h%koff
             IF ( point_index(k,j,i) < 0 )  THEN
-               surfaces%npoints   = surfaces%npoints + 1    
+               surfaces%npoints   = surfaces%npoints + 1
                point_index(k,j,i) = point_index_count
-               point_index_count  = point_index_count + 1 
+               point_index_count  = point_index_count + 1
                surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
                surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
@@ -634,7 +640,7 @@
             ENDIF
             IF ( point_index(k,j,i+1) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
+               surfaces%npoints     = surfaces%npoints + 1
                point_index(k,j,i+1) = point_index_count
-               point_index_count    = point_index_count + 1 
+               point_index_count    = point_index_count + 1
                surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
                surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
@@ -642,7 +648,7 @@
             ENDIF
             IF ( point_index(k,j+1,i+1) < 0 )  THEN
-               surfaces%npoints       = surfaces%npoints + 1    
+               surfaces%npoints       = surfaces%npoints + 1
                point_index(k,j+1,i+1) = point_index_count
-               point_index_count      = point_index_count + 1 
+               point_index_count      = point_index_count + 1
                surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
                surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
@@ -650,12 +656,12 @@
             ENDIF
             IF ( point_index(k,j+1,i) < 0 )  THEN
-               surfaces%npoints     = surfaces%npoints + 1    
+               surfaces%npoints     = surfaces%npoints + 1
                point_index(k,j+1,i) = point_index_count
-               point_index_count    = point_index_count + 1 
+               point_index_count    = point_index_count + 1
                surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
                surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
                surfaces%points(3,surfaces%npoints) = zw(k)
             ENDIF
-            
+
             npg                        = npg + 1
             surfaces%polygons(1,npg)   = 4
